{% macro datatable(id='tableData') %}
    <style>
        thead input {
            width: 100%;
        }
    </style>
    <table id="{{ id|replace({' ':''}) }}" class="mdl-data-table" style="width:100%">
        <thead>
        </thead>

        <tbody>
        </tbody>
    </table>

{% endmacro %}

{% macro datatableJS(class, space, tableAction = null, tableFields, where = null, groupBy = null, searching = 'yes',number = 'yes', id = 'tableData', export = false, order = null, methd = null) %}
    <script>
        $(document).ready(function () {
                show_datatable();

                function show_datatable() {
                    {% set data = where %}
                    var whereTxt = '{{ where }}';
                    var exp = '{{ export }}';
                    var where = whereTxt.replace(/&quot;/g, '\"');

                    console.log('wherenya adalah = ' + where);
                    console.log('space adalah = {{ space }}');
                    console.log('class adalah = {{ class }}');
                    console.log('groupBy adalah = {{ groupBy }}');
                    console.log('tableAction adalah = {{ tableAction }}');
                    var button = [];
                    {#console.log('{{ export }}');#}
                    var title = '';

                    {#/**/           console.log('{{ data|replace({"&quot;" : '"'}) }}')#}
                    if ('{{ export }}' === 'yes') {
                        title = "{{ id|replace({' ':''}) }}";

                        button.push({
                            extend: '',
                            className: '',
                            text: '<i class="fa fa-download"></i> Excel',
                            title: 'Tabel ' + title,
                            exportOptions: {
                                modifier: {
                                    page: 'all'
                                },
                                columns: [1, 2, 3, 4, 5, 6]
                            }
                        })
                    }

                    {#$("#{{ id|replace({' ':''}) }} thead tr").clone(true).appendTo( "#{{ id|replace({' ':''}) }} thead" );#}
                    {#$("#{{ id|replace({' ':''}) }} thead tr:eq(1) th").each( function (i) {#}
                    {#    var title = $(this).text();#}
                    {#    $(this).html( '<input type="text" placeholder="Search '+title+'" />' );#}


                    {#} );#}

                    var {{ id|replace({' ':''}) }} =
                    $("#{{ id|replace({' ':''}) }}").DataTable({
                        {% if searching is null %}
                        searching: false,
                        {% endif %}
                        responsive: true,
                        processing: true,
                        serverSide: true,
                        // orderCellsTop: true,
                        // fixedHeader: true,
                        rowReorder: {
                            selector: 'td:nth-child(2)'
                        },
                        {% if methd != null %}
                        drawCallback : function(param){
                            window["{{ methd }}"](param);
                        },
                        {% endif %}
                        dom: 'Bfrtip',
                        buttons: button,
                        {% if number is not null %}
                        "fnRowCallback": function (nRow, aData, iDisplayIndex, iDisplayIndexFull) {
                            // debugger;
                            var numStart = this.fnPagingInfo().iStart;
                            var index = numStart + iDisplayIndexFull + 1;
                            // var index = iDisplayIndexFull + 1;
                            $("td:first", nRow).html(index);
                            return nRow;
                        },
                        {% endif %}
                        language: {
                            processing: "<div class='loading-datatables'>" +
                                "<i class='fa fa-spinner fa-pulse'></i>" +
                                    {#"<img src='{{ asset('images/loadingdatatables.png')}}'/>" +#}
                                "<p>Tunggu Sebentar ya..</p>" +
                                "</div>"
                        },
                        ajax: {
                            url: '{{ path('datatable-get') }}',
                            method: 'GET',
                            data: {
                                'class': '{{ class }}',
                                'space': '{{ space }}',
                                'actions': '{{ tableAction }}',
                                'where': where,
                                'groupBy': '{{ groupBy }}'
                                // ,
                                // ,
                                {#'where' : JSON.parse({{ where|json_encode() }})#}
                            }
                        },
                        columnDefs: [
                            {% set num = 0 %}
                            {% if number == 'yes' %}
                            {% set num = 1 %}
                            {
                                "title": "#",
                                "searchable": false,
                                "orderable": false,
                                "targets": 0,
                            },
                            {% endif %}
                            {% set lenfields = tableFields|length-1 %}
                            {% set index = 1 %}
                            {% for i in 0..lenfields %}
                            {
                                "title": "{{ tableFields[i]['label'] }}",
                                'targets': {{ i + num }},
                                'searchable': true,
                                'orderable': true
                            },
                            {% endfor %}
                            {% if ((tableAction is not  null) and (tableAction != '')) %}
                            {
                                "title": "Action",
                                "width": "100",
                                'targets': {{ lenfields+num+1 }},
                                "searchable": false,
                                "orderable": false,
                            }
                            {% endif %}
                        ],
                        columns: [
                            // {"defaultContent": ""},
                            {% if number == 'yes' %}
                            {
                                "className": 'details-control',
                                "orderable": false,
                                "data": null,
                                "defaultContent": ''
                            },
                            {% endif %}
                            // {"defaultContent": ""},
                            {% for i in 0..lenfields %}
                            {"data": "{{ tableFields[i]['field'] }}"},
                            {% endfor %}

                            {% if  tableAction > 2 %}
                            {
                                "data":
                                    "action", "width":
                                    "150"
                            }
                            {% elseif  tableAction is not null and tableAction != '' %}
                            {
                                "data":
                                    "action", "width":
                                    "100"
                            }

                            {% endif %}

                        ],
                    {% if order is not null %}
                        "order":
                            [['{{ order['column'] }}', '{{ order['type'] }}']]
                    {% endif %}
                    })
                    ;
                    {% if number == 'yes' %}
                    {{ id|replace({' ':''}) }}.
                    on('order.dt search.dt', function () {
                        {{ id|replace({' ':''}) }}.
                        column(0, {search: 'applied', order: 'applied'}).nodes().each(function (cell, i) {
                            cell.innerHTML = i + 1;
                            {{ id|replace({' ':''}) }}.
                            cell(cell).invalidate('dom');
                        });
                    }).draw();
                    {% endif %}
                    console.log('jumlah adalah : {{ lenfields+num+1 }}')
                    {% if tableAction is not null and tableAction != '' %}
                    {{ id|replace({' ':''}) }}.on('draw', function () {
                        $('tr th:nth-child({{ lenfields+num+2 }})').each(function () {
                            $(this).addClass('actionButton')
                        })
                    });
                    {% endif %}
                }

                $(document).on("click", 'a#deleteData', function (ev) {
                    var idDel = ev.currentTarget.getAttribute('data-cred');
                    alertify.confirm('Warning', 'Apakah anda yakin untuk menghapus data', function () {

                            var xhr1 = new XMLHttpRequest();
                            xhr1.open('POST', "{{ path('datatable-delete') }}", true);
                            xhr1.onload = function () {
                                if (xhr1.status === 200 && xhr1.readyState === 4) {
                                    var data = JSON.parse(xhr1.response);
                                    // showToast(data['status'], data['label']);
                                    alertify.notify(data['status'], data['label'], 5, function () {
                                    });

                                    $("#{{ id|replace({' ':''}) }}").DataTable().
                                    ajax.reload();
                                }
                            };
                            var data = new FormData();//end onreadystate
                            // data.append('id', ev.currentTarget.getAttribute('data-cred'));
                            data.append('id', idDel);
                            data.append('class', '{{ class }}');
                            data.append('space', '{{ space }}');
                            xhr1.send(data);

                        }
                        , function () {
                            // showToast('Data tidak dihapus', 'warning');
                            alertify.notify('Data tidak dihapus', 'danger', 5, function () {
                            });

                        }
                    ).set({transition: 'fade'});
                });
                $(".loading-datatables").append("");

            }
        );

        jQuery.fn.dataTableExt.oApi.fnPagingInfo = function (oSettings) {
            return {
                "iStart": oSettings._iDisplayStart,
                "iEnd": oSettings.fnDisplayEnd(),
                "iLength": oSettings._iDisplayLength,
                "iTotal": oSettings.fnRecordsTotal(),
                "iFilteredTotal": oSettings.fnRecordsDisplay(),
                "iPage": oSettings._iDisplayLength === -1 ?
                    0 : Math.ceil(oSettings._iDisplayStart / oSettings._iDisplayLength),
                "iTotalPages": oSettings._iDisplayLength === -1 ?
                    0 : Math.ceil(oSettings.fnRecordsDisplay() / oSettings._iDisplayLength)
            };
        };

        // </script>
{% endmacro %}